---
title: XRWebGLLayerInit.framebufferScaleFactor
slug: Web/API/XRWebGLLayerInit/framebufferScaleFactor
tags:
  - API
  - AR
  - Buffer
  - Factor
  - Frame buffer
  - Property
  - Reality
  - Reference
  - Scale
  - Scaling
  - VR
  - Virtual
  - WeXR API
  - WebXR
  - WebXR Device API
  - XR
  - XRWebGLLayerInit
  - augmented
  - framebuffer
  - framebufferScaleFactor
  - resolution
  - size
---
<p>{{APIRef("WebXR Device API")}}{{securecontext_header}}</p>

<p><span class="seoSummary">The {{domxref("XRWebGLLayerInit")}} dictionary's <code><strong>framebufferScaleFactor</strong></code> property, when specified upon instantiating a new {{domxref("XRWebGLLayer")}} using its constructor, {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}}, specifies the scaling factor to use when determining the size of the frame buffer to use when rendering the scene, relative to the default XR device display resolution.</span></p>

<p>For example, a value of 1.0 indicates that the frame buffer should be the same resolution as the actual display, while a value of 0.5 indicates that the frame buffer should be half the resolution of the display. A value of 2.0, on the other hand, creates a frame buffer whose resolution is <em>double</em> that of the actual display buffer.</p>

<p>There are valid use cases for all of these kinds of scaling. See {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Performance", "Managing rendering quality")}} for more information.</p>

<p>You can determine the scaling factor that you would need to apply to match the default frame buffer resolution by using the {{domxref("XRWebGLLayer.getNativeFramebufferScaleFactor()")}} static function.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">let layerInit = {
  framebufferScaleFactor: <em>scaleFactor</em>
};
let glLayer = new XRWebGLLayer(xrSession, gl, layerInit);

let glLayer = new XRWebGLLayer(xrSession, gl, { framebufferScaleFactor: <em>scaleFactor</em> });
</pre>

<h3 id="Value">Value</h3>

<p>A floating-point value indicating a multiplier to apply to the default frame buffer resolution in order to determine the resolution of the frame buffer for the {{domxref("XRWebGLLayer")}}.</p>

<h2 id="Example">Example</h2>

<p>In this example, a new {{domxref("XRWebGLLayer")}} is created for a WebXR session, <code>xrSession</code>, with a frame buffer whose resolution is half that of the default display resolution of the XR device.</p>

<pre class="brush: js">xrSession.updateRenderState({
  baseLayer: new XRWebGLLayer(xrSession, gl, {
     framebufferScaleFactor: 0.5
  });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayerinit-framebufferscalefactor','XRWebGLLayerInit.framebufferScaleFactor')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayerInit.framebufferScaleFactor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Performance">WebXR performance guide</a></li>
 <li>{{domxref("XRWebGLLayer.getNativeFramebufferScaleFactor()")}}</li>
</ul>
